=== debian/changelog ===
calamares (3.2.26-1~bpo10+1) buster-backports; urgency=medium

  * Backport for buster
  * Downgrade to debhelper-compat (=12)

 -- Jonathan Carter <jcc@debian.org>  Mon, 29 Jun 2020 19:50:23 +0200

calamares (3.2.26-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Sun, 21 Jun 2020 14:29:12 +0200

calamares (3.2.24-1) unstable; urgency=medium

  * New upstream release
  * Upgrade to debhelper-compat (= 13)

 -- Jonathan Carter <jcc@debian.org>  Sat, 16 May 2020 11:16:17 +0200

calamares (3.2.23-1) unstable; urgency=medium

  * New upstream release
  * Add lintian override for spelling mistake false-positive

 -- Jonathan Carter <jcc@debian.org>  Fri, 17 Apr 2020 14:04:57 +0200

calamares (3.2.22-1) unstable; urgency=medium

  * New upstream release
  * Update copyright file
  * Remove spelling error lintian override (no longer needed)

 -- Jonathan Carter <jcc@debian.org>  Wed, 08 Apr 2020 17:45:39 +0200

calamares (3.2.21-1) unstable; urgency=medium

  * New upstream release
  * Declare Rules-Requires-Root: no
  * Override lintian spelling error false-positive

 -- Jonathan Carter <jcc@debian.org>  Sat, 28 Mar 2020 13:25:17 +0200

calamares (3.2.20-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Mon, 02 Mar 2020 10:20:06 +0200

calamares (3.2.19.1-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Tue, 25 Feb 2020 08:47:28 +0200

calamares (3.2.19-1) unstable; urgency=medium

  * New upstream release

 -- Jonathan Carter <jcc@debian.org>  Mon, 24 Feb 2020 11:06:20 +0200
