=== src/modules/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,9 @@
 
 foreach( _category ${_use_categories} )
     list( FIND _found_categories ${_category} _found )
+    if ( ${USE_${_category}} STREQUAL "none" )
+        set( _found 0 )
+    endif()
     if ( _found EQUAL -1 )
         message( FATAL_ERROR "USE_${_category} is set to ${USE_${_category}} and no module matches." )
     endif()
